#include "IIC.h"

u8 ack;

void Delay2us()		//@11.0592MHz
{
	unsigned long edata i;

	_nop_();
	i = 4UL;
	while (i) i--;
}

void IIC_START(void)		// ź
{
	SCL = 1;
	SDA = 1;
	Delay2us();
	SDA = 0;
	Delay2us();
	SCL = 0;
	Delay2us();
}

void IIC_STOP(void)		// ֹͣź
{
	SCL = 0;
	SDA = 0;
	Delay2us();
	SCL = 1;
	Delay2us();
	SDA = 1;
	Delay2us();
}

void IIC_SENDACK(void)
{
	SDA = 0;
	Delay2us();
	SCL = 1;
	Delay2us();
	SCL = 0;
	Delay2us();
}

void IIC_SENDNACK(void)
{
	SDA = 1;
	Delay2us();
	SCL = 1;
	Delay2us();
	SCL = 0;
	Delay2us();
}


void IIC_WAITACK(void)
{
	SDA = 1;
	Delay2us();
	SCL = 1;
	Delay2us();
	ack = SDA;
	Delay2us();
	SCL = 0;
	Delay2us();
}


void IIC_SENDBYTE(u8 dat)
{
	u8 i=8;
	do
	{
		if(dat & 0x80)
			SDA = 1;
		else
			SDA = 0;
		Delay2us();
		dat <<= 1;
		SCL = 1;
		Delay2us();
		SCL = 0;
		Delay2us();
	}
	while(--i);
}

u8 IIC_READBYTE(void)
{
	u8 i=8,dat=0;
	SDA = 1;
	do
	{
		SCL = 1;
		Delay2us();
		dat <<= 1;
		if(SDA)
			dat |= 1;
		SCL = 0;
		Delay2us();
	}
	while(--i);
	return dat;
}

// -------------------------ܺд------------------------------
void IIC_Write_NByte(u8 slave, u8 addr, u8 *p, u8 number)
{
	IIC_START();
	IIC_SENDBYTE(slave);
	IIC_WAITACK();
	if(!ack)
	{
		IIC_SENDBYTE(addr);
		IIC_WAITACK();
		if(!ack)
		{
			do
			{
				IIC_SENDBYTE(*p);
				p++;
				IIC_WAITACK();
				if(ack)
					break;
			}
			while(--number);
		}
	}
	IIC_STOP();
}


void IIC_Read_NByte(u8 slave, u8 addr, u8 *p, u8 number)
{
	IIC_START();
	IIC_SENDBYTE(slave);
	IIC_WAITACK();
	if(!ack)
	{
		IIC_SENDBYTE(addr);
		IIC_WAITACK();
		if(!ack)
		{
			IIC_START();
			IIC_SENDBYTE(slave|0x01);
			IIC_WAITACK();
			if(!ack)
			{
				do
				{
					*p = IIC_READBYTE();
					p++;
					if(number!=1)
						IIC_SENDACK();
				}
				while(--number);
				IIC_SENDNACK();
			}
		}
	}
	IIC_STOP();
}

